
# Autogenerated by mlir-tblgen; don't manually edit.

from ._ods_common import _cext as _ods_cext
from ._ods_common import extend_opview_class as _ods_extend_opview_class, segmented_accessor as _ods_segmented_accessor, equally_sized_accessor as _ods_equally_sized_accessor, get_default_loc_context as _ods_get_default_loc_context, get_op_result_or_value as _get_op_result_or_value, get_op_results_or_values as _get_op_results_or_values
_ods_ir = _ods_cext.ir

try:
  from . import _gpu_transform_ops_ext as _ods_ext_module
except ImportError:
  _ods_ext_module = None

import builtins


from ._transform_ops_gen import _Dialect

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class EliminateBarriersOp(_ods_ir.OpView):
  OPERATION_NAME = "transform.apply_patterns.gpu.eliminate_barriers"

  _ODS_REGIONS = (0, True)

  def __init__(self, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class MapForallToBlocks(_ods_ir.OpView):
  OPERATION_NAME = "transform.gpu.map_forall_to_blocks"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, target, *, grid_dims=None, generate_gpu_launch=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(target))
    _ods_context = _ods_get_default_loc_context(loc)
    if grid_dims is not None: attributes["grid_dims"] = (grid_dims if (
        issubclass(type(grid_dims), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseI64ArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseI64ArrayAttr')(grid_dims, context=_ods_context))
    if bool(generate_gpu_launch): attributes["generate_gpu_launch"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def target(self):
    return self.operation.operands[0]

  @builtins.property
  def grid_dims(self):
    if "grid_dims" not in self.operation.attributes:
      return None
    return self.operation.attributes["grid_dims"]

  @grid_dims.setter
  def grid_dims(self, value):
    if value is not None:
      self.operation.attributes["grid_dims"] = value
    elif "grid_dims" in self.operation.attributes:
      del self.operation.attributes["grid_dims"]

  @grid_dims.deleter
  def grid_dims(self):
    del self.operation.attributes["grid_dims"]

  @builtins.property
  def generate_gpu_launch(self):
    return "generate_gpu_launch" in self.operation.attributes

  @generate_gpu_launch.setter
  def generate_gpu_launch(self, value):
    if bool(value):
      self.operation.attributes["generate_gpu_launch"] = _ods_ir.UnitAttr.get()
    elif "generate_gpu_launch" in self.operation.attributes:
      del self.operation.attributes["generate_gpu_launch"]

  @generate_gpu_launch.deleter
  def generate_gpu_launch(self):
    del self.operation.attributes["generate_gpu_launch"]

  @builtins.property
  def result(self):
    return self.operation.results[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class MapNestedForallToThreads(_ods_ir.OpView):
  OPERATION_NAME = "transform.gpu.map_nested_forall_to_threads"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, target, *, block_dims=None, warp_dims=None, sync_after_distribute=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(target))
    _ods_context = _ods_get_default_loc_context(loc)
    if block_dims is not None: attributes["block_dims"] = (block_dims if (
        issubclass(type(block_dims), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseI64ArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseI64ArrayAttr')(block_dims, context=_ods_context))
    if warp_dims is not None: attributes["warp_dims"] = (warp_dims if (
        issubclass(type(warp_dims), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseI64ArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseI64ArrayAttr')(warp_dims, context=_ods_context))
    if sync_after_distribute is not None: attributes["sync_after_distribute"] = (sync_after_distribute if (
        issubclass(type(sync_after_distribute), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('BoolAttr')) else
          _ods_ir.AttrBuilder.get('BoolAttr')(sync_after_distribute, context=_ods_context))
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def target(self):
    return self.operation.operands[0]

  @builtins.property
  def block_dims(self):
    return self.operation.attributes["block_dims"]

  @block_dims.setter
  def block_dims(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["block_dims"] = value

  @builtins.property
  def warp_dims(self):
    if "warp_dims" not in self.operation.attributes:
      return None
    return self.operation.attributes["warp_dims"]

  @warp_dims.setter
  def warp_dims(self, value):
    if value is not None:
      self.operation.attributes["warp_dims"] = value
    elif "warp_dims" in self.operation.attributes:
      del self.operation.attributes["warp_dims"]

  @warp_dims.deleter
  def warp_dims(self):
    del self.operation.attributes["warp_dims"]

  @builtins.property
  def sync_after_distribute(self):
    return self.operation.attributes["sync_after_distribute"]

  @sync_after_distribute.setter
  def sync_after_distribute(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["sync_after_distribute"] = value

  @builtins.property
  def result(self):
    return self.operation.results[0]
